import boto3
import json
import os
import re
import hashlib


def hash_string(string):
    hash_object = hashlib.sha1(str.encode(string))
    hex_dig = hash_object.hexdigest()
    return hex_dig


def _get_entities(text, awskey, awssecret):
    file_path = os.path.join('plugin/external/', '{}.json'.format(hash_string(text)))
    if not os.path.exists(file_path):
        client = boto3.client(service_name='comprehendmedical', region_name='eu-west-1', aws_access_key_id=awskey, aws_secret_access_key=awssecret)
        result = client.detect_entities(Text=text)
        with open(file_path, 'w', encoding='utf8') as writefile:
            json.dump(result, writefile, indent=1, ensure_ascii=True)
    else:
        with open(file_path, 'r', encoding='utf8') as readfile:
            result = json.load(readfile)

    return json.dumps(result)


def expr(text, awskey, awssecret):
    result = [_get_entities(text, awskey, awssecret)]
    return result
